
%global pkg_name xmonad
%global pkgver %{pkg_name}-%{version}


Name:           %{pkg_name}
Version:        0.17.2
Release:    1%{?dist}
Summary:        A tiling window manager

License:        BSD-3-Clause
Url:            https://hackage.haskell.org/package/%{name}
Source0:        https://hackage.haskell.org/package/%{pkgver}/%{pkgver}.tar.gz
Source2:        xmonad-session.desktop
Source3:        xmonad-start
Source4:        xmonad.desktop
Source5:        README.fedora
Source6:        xmonad-mate-session.desktop
Source7:        xmonad.hs

BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-rpm-macros
BuildRequires:  ghc-X11-devel
BuildRequires:  ghc-base-devel
BuildRequires:  ghc-containers-devel
BuildRequires:  ghc-data-default-class-devel
BuildRequires:  ghc-directory-devel
BuildRequires:  ghc-filepath-devel
BuildRequires:  ghc-mtl-devel
BuildRequires:  ghc-process-devel
BuildRequires:  ghc-setlocale-devel
BuildRequires:  ghc-time-devel
BuildRequires:  ghc-transformers-devel
BuildRequires:  ghc-unix-devel
%if %{with ghc_prof}
BuildRequires:  ghc-X11-prof
BuildRequires:  ghc-base-prof
BuildRequires:  ghc-containers-prof
BuildRequires:  ghc-data-default-class-prof
BuildRequires:  ghc-directory-prof
BuildRequires:  ghc-filepath-prof
BuildRequires:  ghc-mtl-prof
BuildRequires:  ghc-process-prof
BuildRequires:  ghc-setlocale-prof
BuildRequires:  ghc-time-prof
BuildRequires:  ghc-transformers-prof
BuildRequires:  ghc-unix-prof
%endif
BuildRequires:  desktop-file-utils
Requires:       xmonad-basic = %{version}-%{release}
Requires:       xmonad-config = %{version}-%{release}

%description
Xmonad is a tiling window manager for X. Windows are arranged automatically to
tile the screen without gaps or overlap, maximising screen use. All features of
the window manager are accessible from the keyboard: a mouse is strictly
optional. xmonad is written and extensible in Haskell. Custom layout
algorithms, and other extensions, may be written by the user in config files.
Layouts are applied dynamically, and different layouts may be used on each
workspace. Xinerama is fully supported, allowing windows to be tiled on several
screens.

This is a meta-package that installs xmonad-basic and ghc-xmonad-contrib-devel,
allowing xmonad to be customized with "~/.xmonad/xmonad.hs".

To use xmonad with GNOME/MATE, please install xmonad-mate.


%package -n ghc-%{name}
Summary:        Haskell %{name} library

%description -n ghc-%{name}
This package provides the Haskell %{name} shared library.


%package -n ghc-%{name}-devel
Summary:        Haskell %{name} library development files
Provides:       ghc-%{name}-static = %{version}-%{release}
Provides:       ghc-%{name}-static = %{version}-%{release}
%if %{defined ghc_version}
Requires:       ghc-compiler = %{ghc_version}
%endif
Requires:       ghc-%{name} = %{version}-%{release}

%description -n ghc-%{name}-devel
This package provides the Haskell %{name} library development files.


%package basic
Summary:        A tiling window manager
Requires:       xmonad-core = %{version}-%{release}
Requires:       xterm
Requires:       dmenu
Requires:       zenity

%description basic
xmonad is a tiling window manager for X. Windows are arranged
automatically to tile the screen without gaps or overlap, maximising
screen use. All features of the window manager are accessible from
the keyboard: a mouse is strictly optional. xmonad is written and
extensible in Haskell. Custom layout algorithms, and other
extensions, may be written by the user in config files. Layouts are
applied dynamically, and different layouts may be used on each
workspace. Xinerama is fully supported, allowing windows to be tiled
on several screens.

This meta-package allows running the default basic upstream xmonad
configuration with xterm and dmenu.

If you want to customize xmonad, please install xmonad or xmonad-mate.


%package config
Summary:        xmonad config
Requires:       xmonad-core = %{version}-%{release}
Requires:       ghc-xmonad-devel = %{version}-%{release}
Requires:       ghc-xmonad-contrib-devel

%description config
This package provides a basic desktop configuration for xmonad.


%package core
Summary:        A tiling window manager
Requires:       xmessage

%description core
This package just provides the core xmonad window manager program.

To run the default xmonad configuration you should install xmonad-basic.
If you want to customize xmonad please install either xmonad or xmonad-mate.


%package mate
Summary:        xmonad MATE session
Requires:       xmonad-config = %{version}-%{release}
Requires:       mate-session-manager, mate-terminal
Requires:       mate-panel, mate-settings-daemon

%description mate
xmonad is a tiling window manager for X. Windows are arranged
automatically to tile the screen without gaps or overlap, maximising
screen use. All features of the window manager are accessible from
the keyboard: a mouse is strictly optional. xmonad is written and
extensible in Haskell. Custom layout algorithms, and other
extensions, may be written by the user in config files. Layouts are
applied dynamically, and different layouts may be used on each
workspace. Xinerama is fully supported, allowing windows to be tiled
on several screens.

This package adds a "xmonad-mate" X session configuration
so that xmonad can be started easily from GDM to run
in a MATE session.


%if %{with haddock}
%package -n ghc-%{name}-doc
Summary:        Haskell %{name} library documentation
BuildArch:      noarch
Requires:       ghc-filesystem

%description -n ghc-%{name}-doc
This package provides the Haskell %{name} library documentation.
%endif


%if %{with ghc_prof}
%package -n ghc-%{name}-prof
Summary:        Haskell %{name} profiling library
Requires:       ghc-%{name}-devel = %{version}-%{release}
Supplements:    (ghc-%{name}-devel and ghc-prof)

%description -n ghc-%{name}-prof
This package provides the Haskell %{name} profiling library.
%endif


%prep
%setup -q
cp -p %SOURCE5 .


%build
%ghc_lib_build


%install
%ghc_lib_install

mv %{buildroot}%{_defaultlicensedir}/%{name}{,-core}

install -p -m 0644 -D man/%{name}.1 %{buildroot}%{_mandir}/man1/%{name}.1
install -p -m 0644 -D %SOURCE2 %{buildroot}%{_datadir}/xsessions/%{name}.desktop
install -p -m 0755 -D %SOURCE3 %{buildroot}%{_bindir}/%{name}-start
desktop-file-install --dir=%{buildroot}%{_datadir}/applications %{SOURCE4}
install -p -m 0644 -D %SOURCE6 %{buildroot}%{_datadir}/xsessions/%{name}-mate.desktop
install -p -m 0644 -D %SOURCE7 %{buildroot}%{_datadir}/xmonad/xmonad.hs


%check
%if %{with tests}
%cabal_test
%endif


%files


%files basic
%{_datadir}/xsessions/%{name}.desktop


%files config
%{_datadir}/xmonad/xmonad.hs


%files core
%license LICENSE
%doc CHANGES.md README.fedora README.md
%doc man/xmonad.{hs,1{.html,.markdown}}
%attr(755,root,root) %{_bindir}/%{name}
%attr(755,root,root) %{_bindir}/%{name}-start
%{_mandir}/man1/%{name}.1*
%{_datadir}/applications/%{name}.desktop


%files mate
%{_datadir}/xsessions/%{name}-mate.desktop


%files -n ghc-%{name} -f ghc-%{name}.files
%license LICENSE


%files -n ghc-%{name}-devel -f ghc-%{name}-devel.files
%doc CONTRIBUTING.md TUTORIAL.md


%if %{with haddock}
%files -n ghc-%{name}-doc -f ghc-%{name}-doc.files
%license LICENSE
%endif


%if %{with ghc_prof}
%files -n ghc-%{name}-prof -f ghc-%{name}-prof.files
%endif


%changelog
* Mon Apr 15 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.17.2-1
- initial build
